<?php

class QuantikUIGenerator extends AbstractUIGenerator{
    protected static function getButtonClass(PieceQuantik $piece): string{
       return "<button type='submit' name='active' disabled > $piece </button>";
    }

    protected static function getDivPlateauQuantik(PlateauQuantik $plateau): string{
        $html = "<div class='plateau'>";
        $html.= "<table>";
        for ($i = 0; $i < PlateauQuantik::NBROWS; $i++){
            $html.="<tr>";
            for($j = 0; $j < PlateauQuantik::NBCOLS; $j++){
                $html.= "<td>".$plateau->getPiece($i, $j)->__toString()."</td>";
            }
            $html.="</tr>";
        }
        $html.="</table></div>";
        return $html;
    }

    public static function getDivPiecesDisponibles(ArrayPieceQuantik $apq):string
    {
        $html="<div class='pieceDispo'>";
        for($i = 0; $i < $apq->count(); $i++) {
            $piece =  $apq->getPieceQuantik($i);
            $html.= "<button type='submit' name='' disabled >$piece</button>";
        }
        return $html.='</div>';
    }


    protected static function getFormSelectionPiece(ArrayPieceQuantik $apq):string{
        $html = '';
        for($i = 0; $i < $apq->count(); $i++) {
            $html .= "<form action='traitementV2.php' method='post'>";
            $piece =  $apq->getPieceQuantik($i);
            $html .= '<input type="hidden" name="piece" value="'.$i.'"/>';
            $html .= "<button type='submit' name='action' value='choisirPiece'>$piece</button>";
            $html.="</form>";
        }
        return $html;
    }
    
    protected static function getFormPlateauQuantik(PlateauQuantik $plateau, PieceQuantik $piece):string
    {
        $html= "<div class='plateau'>";
        $action = new ActionQuantik($plateau);
        for($i =0; $i < PlateauQuantik::NBROWS; $i++){
            $html.="<div class= 'ligne'>";
            for($j = 0; $j < PlateauQuantik::NBCOLS; $j++){
                $case = $plateau->getPiece($i,$j);
                if($action->isValidePose($i,$j, $piece) && $case->getForme() === PieceQuantik::VOID){
                    $html.= "<form action='traitementV2.php' method='post'>";
                    $html .= '<input type="hidden" name="caseI" value="'.$i.'"/>';
                    $html .= '<input type="hidden" name="caseJ" value="'.$j.'"/>';
                    $html.="<button type='submit' class='vert' name='action' value='poserPiece'>$case</button>";
                    $html.= "</form>";
                }
                else{
                    $html.="<button type='submit' class='rouge' name='boutonForm' value='$i:$j' disabled>$case</button>";
                }
            }
            $html.= '</div>';
        }
        $html.="</div>";
        return $html;
    }

    protected static function getFormButtonAnnulerChoixPiece():string{
        $html= "<form action='traitementFormQuantik.php' method='post'>";
        $html.="<button type='submit' class='buttonAnnuler' name='annuler'>Annuler</button></form>";
        return $html;
    }

    protected static function getDivMessageVictoire(int $couleur): string{
        $color = "";
        if($couleur === PieceQuantik::WHITE){
            $color .= "Blancs";
        } else{
            $color .= "Noirs";
        }
        return "<div class='Victoire'> 
                    <p>  Victoire des $color </p>
                </div>";
    }

    protected  static function getLienRecommencer(): string{
        return "<a id='retry' href='pageChoixPiece.php'>Recommencer</a>";
    }

    public static function getPageSelectionPiece(QuantikGame $quantik, int $couleurActive): string{
        $html = "";
        $pieces = array();
        if($couleurActive == PieceQuantik::WHITE){
            $html.= AbstractUIGenerator::getDebutHTML("Choix pièces blanches");
            $html.= QuantikUIGenerator::getDivPlateauQuantik($quantik->plateau);
            $html.= QuantikUIGenerator::getDivPiecesDisponibles($quantik->piecesNoires);
            $pieces = $quantik->piecesBlanches;
        } else{
            $html.= AbstractUIGenerator::getDebutHTML("Choix pièces noirs");
            $html.= QuantikUIGenerator::getDivPlateauQuantik($quantik->plateau);
            $html.= QuantikUIGenerator::getDivPiecesDisponibles($quantik->piecesBlanches);
            $pieces = $quantik->piecesNoires;
        }
        $html .= QuantikUIGenerator::getFormSelectionPiece($pieces);
        return $html . AbstractUIGenerator::getFinHTML();
    }

    public static function getPagePosePiece(QuantikGame $quantik, int $couleurActive, int $posSelection): string{
        $html ="";
        $pieces = array();
        if($couleurActive == PieceQuantik::WHITE){
            $html .= AbstractUIGenerator::getDebutHTML("Pose piece blanche");
            $pieces = $quantik->piecesBlanches;
        } else{
            $html .= AbstractUIGenerator::getDebutHTML("Pose piece noir");
            $pieces = $quantik->piecesNoires;
        }
        $html .= QuantikUIGenerator::getFormPlateauQuantik($quantik->plateau, $pieces->getPieceQuantik($posSelection));
        $html .= QuantikUIGenerator::getFormButtonAnnulerChoixPiece();
        return $html . AbstractUIGenerator::getFinHTML();
    }

    public static function getPagePoseVictoire(QuantikGame $quantik, int $couleurActive): string{
        $html = AbstractUIGenerator::getDebutHTML();
        $pieces = array();
        if($couleurActive == PieceQuantik::WHITE){
            $pieces = $quantik->piecesBlanches;
        } else{
            $pieces = $quantik->piecesNoires;
        }
        $html .= QuantikUIGenerator::getDivMessageVictoire($couleurActive);
        $html.= QuantikUIGenerator::getLienRecommencer();
        return $html .= AbstractUIGenerator::getFinHTML();
    }
}